describe('getweatherdatatest', function() {
  var weatherHandler;
  var document;
  var domElements;
  
  beforeEach(function() {
    weatherHandler = new WeatherHandler();
    domElements = {
      lat: { value: 32},
      lon: { value: 44},
      temperature: {innerHTML: ''},
      condition: {innerHTML: ''},
      submit: {}
    };
    
    document = {
      getElementById: function(id) { return domElements[id]; }
    }
  });
  
  it('canary', function() {
    expect(true).to.be.eql(true);
  });
  
  it('getWeatherData sends request to right URL', function() {
    var theURL;
    
    $.get = function(url) {
      theURL = url;
    }
    
    weatherHandler.getWeatherData(document);
    expect(theURL).to.be.eql('/weather?lat=32&lon=44');
  });
  
  it('getWeatherData invokes updateWeatherData on success', function(done) {
    weatherHandler.updateWeatherData = function(theDocument, theData) {
      expect(theDocument).to.be.eql(document);
      expect(theData).to.be.eql('sampleData');
      done();
    }
    
    $.get = function(url, success) {
      success('sampleData');
    }
    
    weatherHandler.getWeatherData(document);
  });
  
  it('updateWeatherData updates the proper DOM elements', function() {
    var weatherData = {temperature: 25, condition: 'nice'};
    
    weatherHandler.updateWeatherData(document, weatherData);
    expect(domElements.temperature.innerHTML).to.be.eql(25);
    expect(domElements.condition.innerHTML).to.be.eql('nice');
  });
  
  it('register click event for submit button', function(done) {
    var weatherHandler = registerEvents(document);
  
    weatherHandler.getWeatherData = function(theDocument) {
      expect(theDocument).to.be.eql(document);
      done();
    }
    
    domElements.submit.onclick();
  });    
});